<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00006000RelacServicoFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "validaServicoRelacionado" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço.
     */
    
    public function validaServicoRelacionado($params){
        
        $queryValidaServRelac = "SELECT COUNT(*) AS VALIDASERV
                                      FROM FCT_RELACSERVICO
                                     WHERE CDSERVORCARELAC IN (".$params['CDSERVORCARELAC'].")
                                       AND CDTPMEDIDASERV = :CDTPMEDIDASERV
                                       AND CDSERVORCA = :CDSERVORCA
                                       AND NRORG = :NRORG";
        
        unset($params['CDSERVORCARELAC']);
        $std = $this->connection->prepare($queryValidaServRelac);
        $std->execute($params);
        $returnValidaServRelac = $std->fetchAll();
        return $returnValidaServRelac;
    }
    
    /**
     * A função "validaServicoRelacionadoUnit" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço para inclusão 
     * de um só item.
     */
     
    
    public function validaServicoRelacionadoUnit($params){
        $queryValidaServRelac = "SELECT COUNT(*) AS VALIDASERV
                                    FROM FCT_RELACSERVICO
                                    WHERE CDSERVORCARELAC = :CDSERVORCARELAC
                                       AND CDSERVORCA     = :CDSERVORCA
                                       AND NRORG          = :NRORG";
        
        $std = $this->connection->prepare($queryValidaServRelac);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    /**
     * Replica no banco o valor do parametro de medida fixada para todos os elementos da árvore
    **/
    public function replicarAlteracaoMedidaServ(array $params){
        $sql = "UPDATE FCT_RELACSERVICO 
                SET IDMEDIDAFIXA = :IDMEDIDAFIXA
                WHERE NRORG = :NRORG
                    AND CDSERVORCARELAC = :CDSERVORCARELAC
                    AND CDSERVORCA IN(SELECT CDSERVORCA
                                    FROM FCT_SERVICOORCA
                                    CONNECT BY PRIOR IDELEMENTO = IDELEMENTOPAI
                                    START WITH IDELEMENTO = :IDELEMENTO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    /**
     * Retorna o nome dos serviços passados como parametro
    **/
    public function getNameServorca($cdservorca, $nrorg) {
            $sql = "SELECT LISTAGG(NMSERVORCA, ',<br>') WITHIN GROUP (ORDER BY NMSERVORCA) AS NMSERVORCA
                FROM FCT_SERVICOORCA
                WHERE CDSERVORCA IN ($cdservorca)
                    AND NRORG    = $nrorg";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}
?>